Unit SFG8R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

function SFG8R(var X :Real; var IERR :Integer): Real;

implementation

function SFG8R(var X :Real; var IERR :Integer): Real;
var
IX :Integer;
X1,Y,PSI :Real;
const
ZERO :Real = 0.0;
ONE :Real = 1.0;
TEN :Real = 10.0;
R1 :Real = 0.0083333333;
R2 :Real = 0.083333333;
SYS001 :Real = 3.1415926535897932384626433832795;
SYS039 :Real = 0.57721566490153286060651200000;
SYS053 :Real = 3.4E38;
label
_10,_20,_30,_40,_50;
begin
{ Result -    SFG8R  FORTRANe }
IERR := 0;
X1 := X;
IX := Trunc(X);
PSI := ZERO;
if ( X <> ZERO ) 
 then goto _10;
PSI := -SYS039;
goto _50;
_10:
if ( X > -ONE ) 
 then goto _30;
if ( IX <> X ) 
 then goto _20;
IERR := 65;
PSI := SYS053;
goto _50;
_20:
X := -X-ONE;
PSI := SYS001*Cos(SYS001*X)/Sin(SYS001*X);
_30:
if ( X >= TEN ) 
 then goto _40;
X := X+ONE;
PSI := PSI-ONE/X;
goto _30;
_40:
Y := ONE/(X*X);
PSI := PSI+Ln(X)+0.5/X-((Y/252.0-R1)*Y+R2)*Y;
_50:
X := X1;
Result := PSI;
exit;
end;

end.
